clear all
close all
clc

%% Settings
addpath('C:\Users\frank\OneDrive\Documenten\MATLAB\Matlab plot functions');
addpath('C:\Users\frank\Documents\MasterAssignment\Experimental_Processing\20210319_Indistinguishable_Haar\Result_structs');

mode_of_interest = 1;
nPhotons = 3;
nModes = 4;
nState = nchoosek(nPhotons + nModes - 1, nPhotons);
tau = [0.1 0.2 0.5 1.0 2.0 5]; % timesteps simulations

for ii = 1 : 150
    load(['Data_Haar_',num2str(ii),'.mat']);
end

Canonical = CanonicalState(4,3);

offset = 75;

% figure(1)
% hold on
% bar(  0 : 3, Canonical, 'FaceColor', [200 200 200]/255, 'EdgeColor', [200 200 200]/255 );
% 
% for ii = 1: 25
%     plot([0 : nPhotons]+(ii-1)*0.01, eval(['Haar_',num2str(offset+ii)]).(['ExpIndistMode',num2str(mode_of_interest)]), 'o','color','red','MarkerFaceColor','red','MarkerSize',5);
% end
% 
% for ii = 1 : 25
%     plot([0 : nPhotons]+(ii-1)*0.01, eval(['Haar_',num2str(offset+ii)]).(['NumIndistMode',num2str(mode_of_interest)]), 'o','color','black','MarkerFaceColor','black','MarkerSize',3);
% end
% 
% for ii = 1 : 25
%     plot([0 : nPhotons]-0.25+(ii-1)*0.01, eval(['Haar_',num2str(offset+ii)]).(['ExpDistMode',num2str(mode_of_interest)]), 's','color','blue','MarkerFaceColor','blue','MarkerSize',5);
% end
% 
% for ii = 1 : 25
%     plot([0 : nPhotons]-0.25+(ii-1)*0.01, eval(['Haar_',num2str(offset+ii)]).(['NumDistMode',num2str(mode_of_interest)]), 's','color','black','MarkerFaceColor','black','MarkerSize',3);
% end
% hold off
% 


    

%% Figure modal
% mode_of_interest = 1;
Canonical = CanonicalState(nModes,nPhotons);
%Classical = ClassicalState(nModes,nPhotons);

%bartot = [Classical' Canonical'];


    figure()
    clf
    
    
    
    
    % make a subplot without white space between them
    %[ha, pos] = tight_subplot(1,6, 0, [.05 0.55], [.1 .1]); %[.15 0.1], [.1 .1]
    [ha, pos] = tight_subplot(2,3, 0, [.15 .15], [.1 0.20]); %[.15 0.1], [.1 .1]
    FancyPlot( get( gcf, 'Number'), 0)
    set( gca, 'FontSize', 10)
    
    for jj = 1 : 6
        % select the frame of the subplot
        axes(ha(jj))
        
        % plotting
        hold on
        
        % For legend
        bar(  NaN, NaN, 'FaceColor', [200 200 200]/255, 'EdgeColor', [200 200 200]/255 ) 
        plot( NaN, NaN, 'o','color','red','MarkerFaceColor','red','MarkerSize',12);
        plot( NaN, NaN, 'o','color','black','MarkerFaceColor','black','MarkerSize',8);
        plot( NaN, NaN, 's','color','blue','MarkerFaceColor','blue','MarkerSize',12);
        plot( NaN, NaN, 's','color','black','MarkerFaceColor','black','MarkerSize',8);
        
%         bar(  0 : nPhotons, Canonical, 'color', [90 90 90]/255)  
        bar(  0 : nPhotons, Canonical, 'FaceColor', [200 200 200]/255, 'EdgeColor', [200 200 200]/255 ,'BarWidth',0.9)  
%         bar(  0 : nPhotons, bartot, 'FaceColor', [200 200 200]/255, 'EdgeColor', [200 200 200]/255 )  
%         b1 = bar(0 : nPhotons , bartot,'BarWidth',1.5);
%         set(b1(2),'FaceColor',[200 200 200]/255, 'EdgeColor', [200 200 200]/255);
%         set(b1(1),'FaceColor',[150 150 150]/255, 'EdgeColor', [150 150 150]/255);
        
        
        offset = (jj-1)*25;
        
        for ii = 1 : 25
        plot([0 : nPhotons]+0.05+(ii-1)*0.01, eval(['Haar_',num2str(offset+ii)]).(['ExpIndistMode',num2str(mode_of_interest)]), 'o','color','red','MarkerFaceColor','red','MarkerSize',5);
        end

        for ii = 1 : 25
            plot([0 : nPhotons]+0.05+(ii-1)*0.01, eval(['Haar_',num2str(offset+ii)]).(['NumIndistMode',num2str(mode_of_interest)]), 'o','color','black','MarkerFaceColor','black','MarkerSize',3);
        end

        for ii = 1 : 25
            plot([0 : nPhotons]-0.05-0.25+(ii-1)*0.01, eval(['Haar_',num2str(offset+ii)]).(['ExpDistMode',num2str(mode_of_interest)]), 's','color','blue','MarkerFaceColor','blue','MarkerSize',5);
        end

        for ii = 1 : 25
            plot([0 : nPhotons]-0.05-0.25+(ii-1)*0.01, eval(['Haar_',num2str(offset+ii)]).(['NumDistMode',num2str(mode_of_interest)]), 's','color','black','MarkerFaceColor','black','MarkerSize',3);
        end

        hold off
        
        % setup the axes
        set( gca, 'xtick', 0:nPhotons, 'ytick', [0 .5 1])
        xlim([-.5 nPhotons+.5])
        ylim([0 1.1])
        box on
 
        set(gca, 'Fontsize',16)

        % setup the time title
        text( .8, 1.03, ['$\tau$ = ', num2str(tau(jj),'%3.1f')],'Fontsize',16,'Interpreter','Latex')

        % set up xticks at the bottom panels
        if jj > 6/2
            set( gca, 'xticklabels', {'0', '1', '2', '3'})
            if jj == 5
                xlabel('Photon number $k$','Interpreter','Latex')
                set(gca, 'Fontsize',16)
            end
        end

        % set up yticks at the left panels
        if mod(jj,6/2) == 1
            set( gca, 'yticklabels', {'0', '0.5', '1.0'})
            ylabel('Probability $P(k)$','Interpreter','Latex')
            set(gca, 'Fontsize',16)
        end
        
        % setup the legend
        if jj == 6
            h = legend({'Thermal state', 'Distinguishable (Exp.)', 'Indistinguishable (Exp.)', 'Distinguishable (Num.)','Indistinguishable (Num.)'},'Interpreter','Latex')
            set(gca, 'Fontsize',16)
            pos = get(h,'position');
            set(h, 'position',[0.78 0.5 pos(3:4)])
        end
        
    end




function P_Canonical = CanonicalState(nModes,nPhotons)
    M = nModes;
    N = nPhotons;
    for k = 0:1:N
        P_Canonical(k+1) = nchoosek(M+N-k-2,N-k)/nchoosek(M+N-1,N);
    end
    
end




