function out = buildFockOut(U,S,d)
    M = length(U);
    
    for q = 1:1:d
        z(q) = sqrt(q);
    end
    % Fock state representation of creation and annihilation operators
    % acting in one mode.
    a = zeros(d)+diag(z(1:d-1),1);
    adag = zeros(d)+diag(z(1:d-1),-1);
    
    ai = zeros(d^M,d^M,M);
    for m=1:M
        atemp = 1;
        for n=M:-1:1
            if n==m
                atemp = kron(adag,atemp);
            else
                atemp = kron(eye(d),atemp);
            end
        end
        ai(:,:,m) = atemp;
    end
    
    aiout = zeros(d^M,d^M,M);
    
    for i=1:M
        temp = 0;
        for j=1:M
            temp = temp + U(j,i)'.*ai(:,:,j);
        end
        aiout(:,:,i) = temp;
    end
    
    vac = zeros(d,1);
    vac(1) = 1;
    vacF = 1;
    for i=1:M
        vacF = kron(vacF,vac);
    end

    atout = eye(d^M);
    for i=1:M
        if S(i)>0
            atout = atout*(aiout(:,:,i)^S(i))./sqrt(factorial(S(i)));
        end
    end
    out = atout * vacF;
end