function data = loadComplexNumbersTxt(Folder, Filename)
% load complex numbers from a txt file
% Folder    The absolute (or relative) path
% FileName  The exact filename
% 
% data      The numerical matix

% input check
if Folder(end) ~= '\'
    Folder = [Folder, '\'];
end

% load in the data
A = importdata([Folder, Filename]);
a = cellfun(@str2num,A,'UniformOutput',false);

% convert to actual data
data = zeros( length(a), length(a{1}));
for ii = 1 : length(a)
    
    data(ii,:) = a{ii};  
end

data = data';
end


