function psiout = Ubuild(u,m)
% takes a unitary in the mode picture and expands in a Fock basis with
% local Fock dimension m.

% %%
% u = UFourier(4);
% m=2;
    v = u;
    for q = 1:1:m
        z(q) = sqrt(q);
    end
    % Fock state representation of creation and annihilation operators
    % acting in one mode.
    a = zeros(m)+diag(z(1:m-1),1);
    adag = zeros(m)+diag(z(1:m-1),-1);
    
    a1 = kron(adag,kron(eye(m),kron(eye(m),eye(m))));
    a2 = kron(eye(m),kron(adag,kron(eye(m),eye(m))));
    a3 = kron(eye(m),kron(eye(m),kron(adag,eye(m))));
    a4 = kron(eye(m),kron(eye(m),kron(eye(m),adag)));
    
    a1out = (v(1,1).*a1+v(1,2).*a2+v(1,3).*a3+v(1,4).*a4);
    a2out = (v(2,1).*a1+v(2,2).*a2+v(2,3).*a3+v(2,4).*a4);
    a3out = (v(3,1).*a1+v(3,2).*a2+v(3,3).*a3+v(3,4).*a4);
    a4out = (v(4,1).*a1+v(4,2).*a2+v(4,3).*a3+v(4,4).*a4);
  


vac = zeros(m,1);
vac(1) = 1;

psiout = a1out*a2out*a3out*kron(kron(kron(vac,vac),vac),vac);

