function W=WignerFromRhoPolar(Rhomn,r,theta)
% Create a 2D representation of W given its density matrix expressed in the Fock states decomposition
% where polar coordinates r and theta should have been created as [r,theta]=meshgrid(0:rstep:rmax,0:thetastep:thetamax)


mmax=size(Rhomn,1);
nmax=size(Rhomn,2);
W=zeros(size(r));


h = waitbar(0,'Calculating W');
for mm=0:mmax-1
    for nn=0:nmax-1
        W=W+Rhomn(mm+1,nn+1)*Wmn(mm,nn,r,theta);
        waitbar((mm+1+(nn+1)/nmax)/mmax);
    end
end
close(h);
