function X = Wmn(m,n,r,theta)
% Create a 2D representation of Wmn where r and theta should have 
% been created as [r,theta]=meshgrid(0:rstep:rmax,0:thetastep:thetamax)
% Uses the math of Garraway and Knight, PRA 46, R5346, 1992 rather than
% Raul-Garcia's thesis.

X=zeros(size(r));

if m>= n
    X=2*((-1)^n)/pi*sqrt(factorial(n)/factorial(m)).*exp(1i*(m-n).*theta).*(r.*2).^(m-n).*exp(-2.*r.^2).*Lpoly(n,m-n,4.*r.^2);
else
    X=2*((-1)^m)/pi*sqrt(factorial(m)/factorial(n)).*exp(1i*(m-n).*theta).*(r.*2).^(n-m).*exp(-2.*r.^2).*Lpoly(m,n-m,4.*r.^2);
end
        