clear all
close all
clc

% Add functions
addpath([pwd,'\Functions\']);

plotReferenceHOM()

function plotReferenceHOM()
% Location signal - idler different source and signal - signal HOM
% interference data
Folder1 = [pwd,'\20211113_Certification_BH\Reference HOM dips\'];

% Location signal - idler same source HOM interference data
Folder2 = [pwd,'\20211117_Certification_Haar\Reference HOM dips\'];

figure
clf
subplot(2,1,1)
load([Folder1,'20211112_data_Signal1_Idler2.mat']) %20210528_data_Signal1_Idler2.mat
hold on
errorbar( data.PositionList, mean(data.Coincidences.C10C11C9C13),...
    std( data.Coincidences.C10C11C9C13)/sqrt(size(data.Coincidences.C10C11C9C13,1)), 'o')

load([Folder1,'20211112_data_Signal1_Signal2.mat'])
errorbar( data.PositionList, mean(data.Coincidences.C10C11C9C13),...
    std( data.Coincidences.C10C11C9C13)/sqrt(size(data.Coincidences.C10C11C9C13,1)), 'o')
hold off
% xlim([5.65 5.85])
ylim([0 1.1*max(ylim)])
ylabel('Counts (Hz)')
legend('S_1-I_2','S_1-S_2')
FancyPlot(3)

subplot(2,1,2)
load([Folder2,'20211116_data_Signal2_Idler2.mat'])
errorbar( data.PositionList, mean(data.Coincidences.C10C11/1e3),...
    std( data.Coincidences.C10C11/1e3)/sqrt(size(data.Coincidences.C10C11,1)), 'o')
ylim([0 1.1*max(ylim)])
% xlim([5.45 5.65])
xlabel('Stage position (mm)')
ylabel('Counts (kHz)')
FancyPlot(3)
end