
%% Data Loading

clear all
clc

%Speed of light
sol = 299792458;

%import the data
folder = 'C:\Users\CorreaAnguitaM\OneDrive - Universiteit Twente\Documents\Projects\Thermalization\20210315_Thermalization\20210923_HOM_Measurement\';

filename = '20210930_data_Signal1_Idler2_Filtered.mat';
data1 = load([folder,filename]);
data1 = data1.data;

filename = '20210930_data_Signal1_Signal2_Filtered.mat';
data2 = load([folder,filename]);
data2 = data2.data;

filename = '20210930_data_Signal2_Idler2_Filtered.mat';
data3 = load([folder,filename]);
data3 = data3.data;

[minimum, idx] = min(mean(data2.Coincidences.C10C11C9C13));
% [minimum, idx] = min(mean(data_F.Coincidences.C10C11));
center = data2.PositionList(idx);

% import the data
% folder = 'C:\Users\CorreaAnguitaM\OneDrive - Universiteit Twente\Documents\Projects\Thermalization\20210824_Testing_HOM\20210901_dataHOMs\';
% 
% filename = '20210903_data_Signal1_Idler2_theoryHOM.mat';
% data1 = load([folder,filename]);
% data1 = data1.data;
% 
% filename = '20210903_data_Signal1_Idler2_optimizedHOM.mat';
% data2 = load([folder,filename]);
% data2 = data2.data;
% 
% filename = '20210903_data_Signal1_Idler2_fullmatrixHOM.mat';
% data3 = load([folder,filename]);
% data3 = data3.data;
% 
% sol = 299792458;
% 
% [minimum, idx] = min(mean(data2.Coincidences.C10C11C9C13));
% [minimum, idx] = min(mean(data_F.Coincidences.C10C11));
% center = data2.PositionList(idx);


%% Raw counts HOM dip plots

f1 = figure();
f1.Position = [300 300 1000 700];

pl = plot((data1.PositionList-center)*1e3/sol,mean(data1.Coincidences.C10C11), 'o-',...
          (data2.PositionList-center)*1e3/sol,mean(data2.Coincidences.C10C11C9C13), 'o-');
      
c = get(pl, 'color');

xlim([-4.5 4.5]*1e-7)
ylim([0 5.8]*1e4)

yline(51.75,'--','Color',c{1})
yline(42.5,'--','Color',c{2})

hold off

ylabel('Coicindences (Hz)','Fontsize', 20)
xlabel('Delay (ps)')


ax = gca(f1);
ax.XAxis.FontSize = 18;
ax.YAxis.FontSize = 18;
set(gca, 'XTick', [-5:5]*1e-7)

set(gca, 'XTickLabel', [-5:5])

% 
% b = get(gca,'XTickLabel');
% set(gca,'XTickLabel',b,'fontsize',18)
% 
title('HOM dip (S1 - I2)','Fontsize', 20)

legend('Unfiltered', "Filtered",'Location','northeastoutside','FontSize',20)


%% Normalized HOM dip plots

f2 = figure();
f2.Position = [300 300 1000 700];

pl = plot((data1.PositionList-center)*1e3/sol,mean(data1.Coincidences.C10C11C9C13)/max(mean(data1.Coincidences.C10C11C9C13)*.98), 'o-',...
          (data2.PositionList-center)*1e3/sol,mean(data2.Coincidences.C10C11C9C13)/(max(mean(data2.Coincidences.C10C11C9C13))*.98), 'o-',...
          (data3.PositionList-center)*1e3/sol,mean(data3.Coincidences.C10C11)/(max(mean(data3.Coincidences.C10C11))*.98), 'o-');

xlim([-5.5 5.5]*1e-7)
ylim([0 1.1])

yline(1,'--','Color','black')
yline(.5,':','Color','black')

hold off

ylabel('Normalized coicindences','Fontsize', 20)
xlabel('Delay (ps)')

ax = gca(f2);
ax.XAxis.FontSize = 18;
ax.YAxis.FontSize = 18;
set(gca, 'XTick', [-5:5]*1e-7);

set(gca, 'XTickLabel', [-5:5]);

title('Normalized HOM dip (S1 - I2)','fontsize', 18);
legend('Theory', "Optimized",'Full matrix','Location','northeastoutside','FontSize',20);
