% process the fiber splitter data
clc
close all
clear 

Folder = 'C:\Users\frank\Documents\MasterAssignment\Experimental_Processing\20210317_Blindness\';
name = '20210317_Thermalization_data_FBS_Characterization_*';
nameStr = '20210317_Thermalization_weightfactor_FBS_Characterization.mat';


files = dir([Folder, name]);
nFiles = length(files);
nTrigger = 1;
doNormalize = 0;
doPlot = 1;


% we want to determine this
weightfactor = zeros(nFiles,14);


for ii = 1 : nFiles
    data{ii} = load( [Folder, files(ii).name]);

    
    % extract singles
    singleNames = fieldnames( data{ii}.data.Singles);
    nSingleName = length( singleNames);
    
    sCounts = zeros( 1, nSingleName);
    for jj = 1 : nSingleName - nTrigger
        sCounts(jj) = mean( data{ii}.data.Singles.(singleNames{jj}));
    end
    totSingles = sum( sCounts);
    
    
    % extract coincidences
    coinNames = fieldnames( data{ii}.data.Coincidences);
    nCoinName = length(coinNames);
    
    cCounts = zeros( 1, nCoinName);
    for jj = 1 : nCoinName
        cCounts(jj) = mean( data{ii}.data.Coincidences.(coinNames{jj}));
        stdCounts(jj) = std( data{ii}.data.Coincidences.(coinNames{jj}));
    end
    totCoin = sum( cCounts);

    
    % get the weightfactors:
    % idea: put all counts in a matrix
    for jj = 1 : nCoinName
        Ch = str2num( coinNames{jj}(2:end-3));
        weightfactor(ii,Ch) = cCounts(jj);
    end
    
    % make a figure
    if doPlot == 1
    figure(ii)
    clf
    subplot(2,1,1)
    if doNormalize == 1
        bar( sCounts/totSingles)
        ylim([0 1])
        ylabel('Relative singles')
    else
        bar( sCounts)
        ylabel('Singles (Hz)')
    end

    title( files(ii).name(32:end-4), 'Interpreter', 'none')
    set( gca, 'xticklabels', singleNames)

    subplot(2,1,2)
    if doNormalize == 1
    bar( cCounts/totCoin)
    ylim([0 1])
        ylabel('Relative coincidences')
    else
        bar( cCounts)
        hold on
        errorbar(cCounts, stdCounts)
        ylabel('Coincidences (Hz)')
    end
    xlabel('Output Channel (numbered)')
    set( gca, 'xticklabels', coinNames)
    xlim([0 max( nCoinName, nSingleName)+1])
    %FancyPlot(ii,2)
    end
    
end
%%
% get the max from each column (= where you send light to that mode0
% normalize to the first one (= arbitrary choice)
% assumption: counts stay constant over time
clc

% compare total number of coincidence counts for each measurement
totCounts = sum(weightfactor,2)
% get the max counts of each detector (=when you send light to it)
W = max(weightfactor);
% normalize
W = W / max(W)

Folder = 'C:\Users\frank\Documents\MasterAssignment\Experimental_Processing\20210317_Blindness\';
save( [Folder, nameStr], 'W')
