% Tussenprogramma om de input naar de GUI FMQ te checken.
% De GUI FMQ wordt aangeroepen en hoeft geen fouten de checken.
% Versie september 2007; Jelle van der Meulen

function fmlsq(x,y,w)
% Controleren of er minimaal twee arrays zijn ingevoerd.
% Als er geen gewichten zijn, worden deze default op 1 gezet
% en de weightflag blijft op 0.
weigthflag=0;
switch nargin
    case {0,1}
        error('Not enough input arguments. At least two data arrays must be supplied.')
    case 2
        ww=ones(1,length(x));
    case 3
        ww=w;
        weigthflag=1;
end

% Rij-arrays maken.
x=x(:).';y=y(:).';w=ww(:).';

% Controleren of de arrays dezelfde lengte hebben.
nx=length(x);ny=length(y);nw=length(ww);
if nx~=ny | nx~=nw
    error('Input arrays have unequal length.')
end

% Controleren of er wel voldoende meetpunten zijn.
if nx<3
    error('Not enough data points.')
end

% Call GUI FMQ; weigthflag zegt of er gewichten zijn meegegeven 0=nee 1=ja
% De arrays x, y en w zijn rij-array
FMQ(weigthflag,x,y,ww)



